    .text
    .balign 4
    .global strlen
# size_t strlen(const char *str)
# a0 holds *str

strlen:
    mv t1, a0             # Save start

#ifdef __riscv_vector
loop:
    vsetvli t0, x0, e8, m8, ta, ma  # Vector of bytes of maximum length
    vle8ff.v v8, (t1)      # Load bytes
    csrr t0, vl           # Get bytes read
    vmseq.vi v0, v8, 0    # Set v0[i] where v8[i] = 0
    vfirst.m t2, v0       # Find first set bit
    add t1, t1, t0        # Bump pointer
    bltz t2, loop         # Not found?

    add a0, a0, t0        # Sum start + bump
    add t1, t1, t2        # Add index
    sub a0, t1, a0        # Subtract start address+bump
#else
1:
    lbu t0, 0(t1)
    beqz t0, 2f
    addi t1, t1, 1
    j 1b
2:
    sub a0, t1, a0
#endif
    ret

